#include <windows.h>
#include "dcopynt.h"

LPTHREAD_START_ROUTINE g_routine;
HANDLE thread1;
DWORD threadid1;
UINT timer1;

BOOL FAR PASCAL WorkingProc(HWND hWnd, unsigned message,WORD wParam, LONG lParam)
{
  DWORD threadstatus;

  switch (message) 
  {
    case WM_INITDIALOG:
      SendDlgItemMessage(hWnd,IDC_PROGRESS,PBM_SETRANGE,0,MAKELPARAM(0,100));
      SendDlgItemMessage(hWnd,IDC_PROGRESS,PBM_SETPOS,0,0);
      stopthread1=0;
      thread1=CreateThread(NULL,0,g_routine,hWnd,0,&threadid1);
      if (thread1==NULL)
      {
       	DisplayLastError(NULL);
	      EndDialog(hWnd,TRUE);
      }
      timer1=SetTimer(hWnd,1,1000,NULL);
      return TRUE;
    case WM_COMMAND:
      switch (wParam)
      {
	case IDCANCEL: 
          stopthread1=1;
	  return TRUE;
	default:
	  break;
      }
      break;
    case WM_USER:
      switch (wParam)
      {
        case THREAD_END:
	  KillTimer(hWnd,timer1);
  	  EndDialog(hWnd,TRUE);
	  break;
      }
    case WM_TIMER:
      GetExitCodeThread(thread1,&threadstatus);
      if (threadstatus!=STILL_ACTIVE)
      {
	KillTimer(hWnd,timer1);
	EndDialog(hWnd,TRUE);
	break;
      }
      DisplayETA(hWnd);
      break;
    case WM_SYSCOMMAND:
      switch (wParam)
      {
        case SC_MINIMIZE:
	  ShowWindow(g_hWnd,SW_MINIMIZE);
	  break;
	case SC_RESTORE:
	  ShowWindow(g_hWnd,SW_RESTORE);
	  break;
      }
      break;
  }
  return FALSE;
}


void Working(LPTHREAD_START_ROUTINE routine,HWND hWnd)
{
  FARPROC workingproc;

  g_routine=routine;
  workingproc=MakeProcInstance((FARPROC)WorkingProc,hInst);
  DialogBox(hInst,MAKEINTRESOURCE(IDD_WORKING),hWnd,(DLGPROC)workingproc);
  FreeProcInstance(workingproc);
}