unsigned char BootMask[ 102 ] =
		   { 0xEB, 0x35,           /* 0000   JMP 0037        */
		     0x90,                 /* 0002   NOP             */
		     /*-- Data of BPB -------------------------------*/

		     0x50, 0x43, 0x49, 0x4E, 0x54, 0x45, 0x52, 0x4E,
		     0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00,
		     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		     0x00, 0x00, 0x00, 0x00,

		     /*-- Actual loading program --------------------*/

		     0xFA,                 /* 0037   CLI             */
		     0xB8, 0x30, 0x00,     /* 0038   MOV     AX,0030 */
		     0x8E, 0xD0,           /* 003B   MOV     SS,AX   */
		     0xBC, 0xFC, 0x00,     /* 003D   MOV     SP,00FC */
		     0xFB,                 /* 0040   STI             */
		     0x0E,                 /* 0041   PUSH    CS      */
		     0x1F,                 /* 0042   POP     DS      */
		     0xBE, 0x66, 0x7C,     /* 0043   MOV     SI,7C66 */
		     0xB4, 0x0E,           /* 0046   MOV     AH,0E   */
		     0xFC,                 /* 0048   CLD             */
		     0xAC,                 /* 0049   LODSB           */
		     0x0A, 0xC0,           /* 004A   OR      AL,AL   */
		     0x74, 0x04,           /* 004C   JZ      0052    */
		     0xCD, 0x10,           /* 004E   INT     10      */
		     0xEB, 0xF7,           /* 0050   JMP     0049    */
		     0xB4, 0x01,           /* 0052   MOV     AH,01   */
		     0xCD, 0x16,           /* 0054   INT     16      */
		     0x74, 0x06,           /* 0056   JZ      005E    */
		     0xB4, 0x00,           /* 0058   MOV     AH,00   */
		     0xCD, 0x16,           /* 005A   INT     16      */
		     0xEB, 0xF4,           /* 005C   JMP     0052    */
		     0xB4, 0x00,           /* 005E   MOV     AH,00   */
		     0xCD, 0x16,           /* 0060   INT     16      */
		     0x33, 0xD2,           /* 0062   XOR     DX,DX   */
		     0xCD, 0x19 };         /* 0064   INT     19      */

char BootMes[] =
  "\nDCOPY V2.81 (c) 1994-1997 by Jorgen Bosman\n\n\r \
  Defective diskette or non-system diskette\n\r \
  Please change diskette and press any key . . .\n\n\r";

